#ifndef FP_SCANNER_H_INCLUDED
#define FP_SCANNER_H_INCLUDED

#include <NImage.h>

#ifdef N_CPP
extern "C"
{
#endif

N_DECLARE_HANDLE(HFPScanner)

typedef void (N_CALLBACK * FPScannerCallback)(HFPScanner hScanner, void * pParam);
typedef void (N_CALLBACK * FPScannerImageScannedCallback)(HFPScanner hScanner, HNImage hImage, void * pParam);

NResult N_API FPScannerGetID(HFPScanner hScanner, NChar * pValue);
NResult N_API FPScannerIsCapturing(HFPScanner hScanner, NBool * pValue);
NResult N_API FPScannerSetIsCapturingChangedCallback(HFPScanner hScanner, FPScannerCallback pCallback, void * pParam);
NResult N_API FPScannerSetFingerPlacedCallback(HFPScanner hScanner, FPScannerCallback pCallback, void * pParam);
NResult N_API FPScannerSetFingerRemovedCallback(HFPScanner hScanner, FPScannerCallback pCallback, void * pParam);
NResult N_API FPScannerSetImageScannedCallback(HFPScanner hScanner, FPScannerImageScannedCallback pCallback, void * pParam);
NResult N_API FPScannerStartCapturing(HFPScanner hScanner);
NResult N_API FPScannerStartCapturingForOneImage(HFPScanner hScanner);
NResult N_API FPScannerStopCapturing(HFPScanner hScanner);

#ifdef N_CPP
}
#endif

#endif // !FP_SCANNER_H_INCLUDED
