/******************************************************************************\
|*                                                                            *|
|*                        Neurotechnologija Images 2.0                        *|
|*                                                                            *|
|* Bmp.h                                                                      *|
|* Header file for Bmp module                                                 *|
|*                                                                            *|
|* Copyright (C) 2005-2006 Neurotechnologija                                  *|
|*                                                                            *|
\******************************************************************************/

#ifndef BMP_H_INCLUDED
#define BMP_H_INCLUDED

#include "NImage.h"

#ifdef N_CPP
extern "C"
{
#endif

/************\
|*          *|
|* BMP load *|
|*          *|
\************/

NResult N_API BmpLoadImageFromFile(const NChar * szFileName, HNImage * pHImage);
NResult N_API BmpLoadImageFromMemory(const void * buffer, NSizeType bufferLength, HNImage * pHImage);
#ifdef N_WINDOWS
NResult N_API BmpLoadImageFromHBitmap(NHandle handle, HNImage * pHImage);
#endif

/************\
|*          *|
|* BMP save *|
|*          *|
\************/

NResult N_API BmpSaveImageToFile(HNImage hImage, const NChar * szFileName);
NResult N_API BmpSaveImageToMemory(HNImage hImage, void * * pBuffer, NSizeType * pBufferLength);
#ifdef N_WINDOWS
NResult N_API BmpSaveImageToHBitmap(HNImage hImage, NHandle * pHandle);
#endif

#ifdef N_CPP
}
#endif

#endif // !BMP_H_INCLUDED
