/******************************************************************************\
|*                                                                            *|
|*                         Neurotechnologija Core 2.0                         *|
|*                                                                            *|
|* NCore.h                                                                    *|
|* Header file for basic NCore library functionality                          *|
|*                                                                            *|
|* Copyright (C) 2005-2006 Neurotechnologija                                  *|
|*                                                                            *|
\******************************************************************************/

#ifndef N_CORE_H_INCLUDED
#define N_CORE_H_INCLUDED

#include "NTypes.h"
#include "NErrors.h"

#ifdef N_CPP
extern "C"
{
#endif

void * NAlloc(NSizeType size);
void * NCAlloc(NSizeType count, NSizeType size);
void * NReAlloc(void * buffer, NSizeType size);
void NFree(void * buffer);

void NCopy(void * dstBuffer, const void * srcBuffer, NSizeType size);
void NMove(void * dstBuffer, const void * srcBuffer, NSizeType size);
void NFill(void * buffer, NByte value, NSizeType size);
#define NClear(data, count) NFill(data, 0, count)
int NCompare(const void * buffer1, const void * buffer2, NSizeType size);

NSizeType NAStrLen(const NAChar * string);
void NCopyAStr(NAChar * dstString, const NAChar * srcString);
NInt NCompareAStr(const NAChar * string1, const NAChar * string2);
NSizeType NStrLen(const NChar * string);
void NCopyStr(NChar * dstString, const NChar * srcString);
NInt NCompareStr(const NChar * string1, const NChar * string2);

#ifdef N_CPP
}
#endif

#endif // !N_CORE_H_INCLUDED
