/******************************************************************************\
|*                                                                            *|
|*                   Neurotechnologija Finger Matcher VF 5.0                  *|
|*                                                                            *|
|* VFMatcherParams.h                                                          *|
|* VFMatcher parameters definition                                            *|
|*                                                                            *|
|* Copyright (C) 2005-2006 Neurotechnologija                                  *|
|*                                                                            *|
\******************************************************************************/

#ifndef VF_MATCHER_PARAMS_H_INCLUDED
#define VF_MATCHER_PARAMS_H_INCLUDED

#include <NParameters.h>

#ifdef N_CPP
extern "C"
{
#endif

// Main parameters

#define VFMP_NAME         10 // Static, Readonly, String | Returns name of the library
#define VFMP_VERSION_HIGH 11 // Static, Readonly, UInt   | Returns high part of the library version
#define VFMP_VERSION_LOW  12 // Static, Readonly, UInt   | Returns low part of the library version
#define VFMP_COPYRIGHT    13 // Static, Readonly, String | Returns copyright of the library

#define VFMP_MATCHING_THRESHOLD 200 // Int | >= 0
#define VFMP_MAXIMAL_ROTATION   201 // Byte | 0..128

#define VFMP_MODE 1000 // Int | Can be one of the following
	#define VFM_MODE_GENERAL                           0
	#define VFM_MODE_DIGITALPERSONA_UAREU            100
	#define VFM_MODE_BIOMETRIKA_FX2000               200
	#define VFM_MODE_BIOMETRIKA_FX3000               201
	#define VFM_MODE_KEYTRONIC_SECUREDESKTOP         300
	#define VFM_MODE_IDENTIX_TOUCHVIEW               400
	#define VFM_MODE_IDENTIX_DFR2090                 401
	#define VFM_MODE_PRECISEBIOMETRICS_100CS         500
	#define VFM_MODE_UPEK_TOUCHCHIP                  600
	#define VFM_MODE_IDENTICATORTECHNOLOGY_DF90      700
	#define VFM_MODE_AUTHENTEC_AFS2                  800
	#define VFM_MODE_AUTHENTEC_AES4000               810
	#define VFM_MODE_AUTHENTEC_AES2501B              811
	#define VFM_MODE_ATMEL_FINGERCHIP                900
	#define VFM_MODE_BMF_BLP100                     1000
	#define VFM_MODE_SECUGEN_HAMSTER                1100
	#define VFM_MODE_ETHENTICA                      1200
	#define VFM_MODE_CROSSMATCH_VERIFIER300         1300
	#define VFM_MODE_NITGEN_FINGKEY_HAMSTER         1400
	#define VFM_MODE_TESTECH_BIOI                   1500
	#define VFM_MODE_DIGENT_IZZIX                   1600
	#define VFM_MODE_STARTEK_FM200                  1700
	#define VFM_MODE_FUJITSU_MBF200                 1800
	#define VFM_MODE_FUTRONIC_FS80                  1900
	#define VFM_MODE_LIGHTUNING_LTTC500             2000
	#define VFM_MODE_TACOMA_CMOS                    2100

#ifdef N_CPP
}
#endif

#endif // !VF_MATCHER_PARAMS_H_INCLUDED
