#include "VFDemoOptions.h"
#include <VFinger.h>
#include "VFDemoDlg.h"

void InitializeDefaultVFDemoOptions(VFDemoOptions * options)
{

	options->b_CheckLowQuality_ = BST_CHECKED;
	options->b_CheckMinMinutia_ = BST_CHECKED;
	options->b_CheckPromptForInfo_ = BST_CHECKED;
	options->b_SearchForDuplicates_ = BST_CHECKED;
	options->b_WarnIfIdsDiffers_ = BST_CHECKED;
	options->e_MinMinutiaCount_ = 10;
	options->b_AllResults_ = BST_CHECKED;
	options->b_AutoMatch_	= BST_CHECKED;
}

void InitializeDefaultVFOptions(VFingerOptions * options)
{

	options->c_FGReturnedImages_ = VF_RETURNED_IMAGE_BINARIZED;
	options->c_FGThreshold_ = 0.01;
	options->c_FMThreshold_ = 0.01;
	options->c_ScanMode_ = VF_MODE_GENERAL;
	options->e_FGMaximalRotation_ = 180;
	options->e_FMMaximalRotation_ = 180;
	options->s_FMMatchingSpeed_ = VF_MATCHING_SPEED_LOW;
}

int NVLint(int value, int defaultValue)
{
	return value == -1 ? defaultValue : value;
}

double NVLdouble(double value, double defaultValue)
{
	return (int)value == -1 ? defaultValue : value;
}

CString NVLstring (CString value,CString defaultValue)
{
	return value == "" ? defaultValue : value;	
}


int GetXMLAttributeInt (MSXML2::IXMLDOMElementPtr spXMLElement, _bstr_t attributeName)
{
	VARIANT attribute;
	INT result = -1;
	attribute = spXMLElement->getAttribute(attributeName);
	if (attribute.vt != VT_NULL)
	{
		return atoi(CString(attribute.bstrVal));
	}
	else return -1;
}

double GetXMLAttributeDouble (MSXML2::IXMLDOMElementPtr spXMLElement,_bstr_t attributeName) {
VARIANT attribute;
attribute = spXMLElement->getAttribute(attributeName);
 if (attribute.vt != VT_NULL) {
	 return atof(CString(attribute.bstrVal));
 } else  return -1;
}


CString GetXMLAttributeString (MSXML2::IXMLDOMElementPtr spXMLElement,_bstr_t attributeName) {
_variant_t attribute;
attribute = spXMLElement->getAttribute(attributeName);
 if ( attribute.vt != VT_EMPTY) {
	 return CString(attribute.bstrVal);
 } else  return CString("");
}


BOOL LoadVFDemoOptions (VFDemoOptions* options,MSXML2::IXMLDOMDocumentPtr &XMLDocument) {
 VARIANT_BOOL bSuccess = false;
 bSuccess = XMLDocument->load(_variant_t("VFDemo.MFC.settings"));
 if (!bSuccess)  { return false; }

 _bstr_t bstrSS(L"VFDemo/Options");
 MSXML2::IXMLDOMNodePtr spXMLNode;
 spXMLNode = XMLDocument->selectSingleNode(bstrSS);
 if (!(bool)spXMLNode) return false;

 MSXML2::IXMLDOMElementPtr spXMLElement;
 spXMLElement = spXMLNode;

 options->b_CheckLowQuality_ = NVLint(GetXMLAttributeInt(spXMLElement,_bstr_t("CheckLowQuality")),options->b_CheckLowQuality_);
 options->b_CheckMinMinutia_ = NVLint(GetXMLAttributeInt(spXMLElement,_bstr_t("CheckMinMinutia")),options->b_CheckMinMinutia_);
 options->b_CheckPromptForInfo_ = NVLint(GetXMLAttributeInt(spXMLElement,_bstr_t("CheckPromptForInfo")),options->b_CheckPromptForInfo_);
 if (options->b_CheckPromptForInfo_ != BST_CHECKED) options->b_CheckPromptForInfo_ = BST_CHECKED;
 options->b_SearchForDuplicates_ = NVLint(GetXMLAttributeInt(spXMLElement,_bstr_t("SearchForDuplicates")),options->b_SearchForDuplicates_);
 options->b_WarnIfIdsDiffers_= NVLint(GetXMLAttributeInt(spXMLElement,_bstr_t("WarnIfIdsDiffers")),options->b_WarnIfIdsDiffers_);
 options->b_AutoMatch_= NVLint(GetXMLAttributeInt(spXMLElement,_bstr_t("AutoMatch")),options->b_AutoMatch_);
 options->b_AllResults_= NVLint(GetXMLAttributeInt(spXMLElement,_bstr_t("AllResults")),options->b_AllResults_);
 options->e_MinMinutiaCount_ = NVLint(GetXMLAttributeInt(spXMLElement,_bstr_t("MinMinutiaCount")),options->e_MinMinutiaCount_);

 spXMLElement.Release();
 spXMLNode.Release();
 return true;
}


BOOL LoadVFOptions (VFingerOptions* options,MSXML2::IXMLDOMDocumentPtr &XMLDocument) {
 VARIANT_BOOL bSuccess = false;
 bSuccess = XMLDocument->load("VFDemo.MFC.settings");
 if (!bSuccess)  { return false; }

 _bstr_t bstrSS(L"VFDemo/VFingerOptions");
 MSXML2::IXMLDOMNodePtr spXMLNode;
 spXMLNode = XMLDocument->selectSingleNode(bstrSS);
 if (!(bool)spXMLNode) return false;

 MSXML2::IXMLDOMElementPtr spXMLElement;
 spXMLElement = spXMLNode;
 options->c_FGReturnedImages_ = NVLint(GetXMLAttributeInt(spXMLElement,_bstr_t("FGReturnedImages")),options->c_FGReturnedImages_);
 options->c_FGThreshold_ = NVLdouble(GetXMLAttributeDouble(spXMLElement,_bstr_t("FGThreshold")),options->c_FGThreshold_);
 options->c_FMThreshold_ = NVLdouble(GetXMLAttributeDouble(spXMLElement,_bstr_t("FMThreshold")),options->c_FMThreshold_);
 options->c_ScanMode_ = NVLint(GetXMLAttributeInt(spXMLElement,_bstr_t("ScanMode")),options->c_ScanMode_);
 options->e_FGMaximalRotation_ =  NVLint(GetXMLAttributeInt(spXMLElement,_bstr_t("FGMaximalRotation")),options->e_FGMaximalRotation_);
 options->e_FMMaximalRotation_ = NVLint(GetXMLAttributeInt(spXMLElement,_bstr_t("FMMaximalRotation")),options->e_FMMaximalRotation_);
 options->s_FMMatchingSpeed_ = NVLint(GetXMLAttributeInt(spXMLElement,_bstr_t("FMMatchingSpeed")),options->s_FMMatchingSpeed_);

 spXMLNode.Release();
 spXMLElement.Release();
 return true;
}

VFingerOptions::VFingerOptions(void)
{
}

VFingerOptions::~VFingerOptions(void)
{
}

VFDemoOptions::VFDemoOptions(void)
{
}


VFDemoOptions::~VFDemoOptions(void)
{
}
