#include "System.h"
#include "GUIApplication.h"

CGUIApplication::CGUIApplication(HINSTANCE handle, int cmdShow, bool initCom)
	: CApplication(handle, initCom), mainForm(NULL)
{
	this->cmdShow = cmdShow;

	// Initialize common controls
	INITCOMMONCONTROLSEX icc;
	icc.dwSize = sizeof(icc);
	icc.dwICC = ICC_BAR_CLASSES | ICC_LISTVIEW_CLASSES | ICC_PROGRESS_CLASS;
	if(!InitCommonControlsEx(&icc)) throw exception("Can not initialize common controls library");

	// Load DLL containing Rich Edit 2.0 (or higher) control (Riched20.dll)
	hRiched20DLL = LoadLibrary(TEXT("Riched20.dll"));
	if(!hRiched20DLL) throw exception("Can not load Riched20.dll");
}

CGUIApplication::~CGUIApplication()
{
	// Unload Riched20.dll
	FreeLibrary(hRiched20DLL);
}

int CGUIApplication::Run(CForm * mainForm)
{
	if(mainForm)
	{
		OnStartRunning();
		this->mainForm = mainForm;
		int result = mainForm->ShowModal(cmdShow);
		delete mainForm;
		OnEndRunning();
		return result;
	}
	else
	{
		CheckRunning();
		return 0;
	}
}

CGUIApplication * GUIApplication()
{
	return dynamic_cast<CGUIApplication *>(Application());
}

bool IsGUIApplication()
{
	return GUIApplication() != NULL;
}

void CheckGUIApplication()
{
	if(IsGUIApplication()) throw exception("Not a GUI application");
}
