#pragma once

#include "XmlUtils.h"

struct VFDemoOptionsImages
{
	string fingerId;
	bool prompt;
};

struct VFDemoOptionsImagesFromFile: VFDemoOptionsImages
{
	int resolution;
};

struct VFDemoOptionsImagesFromScanner: VFDemoOptionsImages
{
};

struct VFDemoOptionsEnrollment
{
	bool checkMinimalMinutiaCount;
	int minimalMinutiaCount;
	bool searchForDuplicates;
	bool warnDifferentFingerId;
};

struct VFDemoOptionsIdentification
{
	bool checkForEmptyDatabase;
	bool useG;
	int databasePercent;
	bool matchAllDatabase;
	bool showAllResults;
};

struct VFDemoOptions
{
	bool useLowQualityImages;
	VFDemoOptionsImagesFromFile imagesFromFile;
	VFDemoOptionsImagesFromScanner imagesFromScanner;
	VFDemoOptionsEnrollment enrollment;
	VFDemoOptionsIdentification identification;
};

extern VFDemoOptions vfDemoDefaultOptions;

void VFDemoInitDefaultOptions();

void VFDemoLoadOptions(MSXML2::IXMLDOMNodePtr node, VFDemoOptions &value);
void VFDemoSaveOptions(MSXML2::IXMLDOMDocumentPtr document, MSXML2::IXMLDOMNodePtr node, const VFDemoOptions &value);
