/********************************************************\
|*                                                      *|
|*                  VeriFinger 4.2 SDK                  *|
|*                                                      *|
|*  ScanManX.h                                          *|
|*    Header file for extended Scanner Manager features *|
|*                                                      *|
|*  Copyright (C) 2002-2004 Neurotechnologija           *|
|*                                                      *|
\********************************************************/

#pragma once

#include <ScanMan.h>

////////////////////////////////
//                            //
// Error and result functions //
//                            //
////////////////////////////////

string SMErrorToString(INT error);
string SMResultToString(INT result);

void SMCheckResult(INT result);


//////////////////////////
//                      //
// Parameters functions //
//                      //
//////////////////////////

bool SMParameterOfType(INT reserved, INT parameter, INT type);
void SMCheckParameterType(INT reserved, INT parameter, INT type);

// Get
DWORD SMGetDWordParameter(INT reserved, INT parameter);
string SMGetStringParameter(INT reserved, INT parameter);

// Get general
INT SMGetParameterType(INT reserved, INT parameter);
string SMGetName(INT reserved = 0);
DWORD SMGetVersionHigh(INT reserved = 0);
DWORD SMGetVersionLow(INT reserved = 0);
string SMGetCopyright(INT reserved = 0);


///////////////////////////////////
//                               //
// Scanner enumeration functions //
//                               //
///////////////////////////////////

string SMGetScannerId(INT index);
void SMGetScannerIds(strings &ids);


/////////////////////////
//                     //
// Capturing functions //
//                     //
/////////////////////////

INT SMStartCapturing(const string &scanner_id, SM_IMAGE_PROC * image_proc, SM_STATE_PROC * state_proc, VOID * param);
INT SMStopCapturing(const string &scanner_id);
INT SMStopCapturing();


///////////////////////////////
//                           //
// Event and state functions //
//                           //
///////////////////////////////

string SMEventToString(DWORD event, const string &scanner_id = emptyString);
string SMStateToString(DWORD state, const string &scanner_id = emptyString);
