#include "System.h"
#include "VFOptionsForm.h"
#include "VFingerX.h"

////////////////////
//                //
// CVFOptionsForm //
//                //
////////////////////

CVFOptionsForm::CVFOptionsForm()
{
	SetMinimizeBox(false);
	SetMaximizeBox(false);
	SetFormBorder(fbDialog);
	SetFormPosition(fpOwnerCenter);
	SetText(STRING("Engine Options"));

	int x = 8, y = 8;

	CLabel * labelMode = new CLabel();
	labelMode->SetText(STRING("&Mode"));
	labelMode->SetLeft(x);
	labelMode->SetWidth(30);
	comboBoxMode = new CComboBox();
	comboBoxMode->SetStyle(cbsDropDownList);
	comboBoxMode->AddItem("General", (void *)VF_MODE_GENERAL);
	comboBoxMode->AddItem("DigitalPersona U.are.U", (void *)VF_MODE_DIGITALPERSONA_UAREU);
#ifndef FINGERCELL
	comboBoxMode->AddItem("BiometriKa FX-2000", (void *)VF_MODE_BIOMETRIKA_FX2000);
	comboBoxMode->AddItem("Keytronics SecureDesktop", (void *)VF_MODE_KEYTRONIC_SECUREDESKTOP);
	comboBoxMode->AddItem("Identix TouchView", (void *)VF_MODE_IDENTIX_TOUCHVIEW);
	comboBoxMode->AddItem("PreciseBiometrics 100CS", (void *)VF_MODE_PRECISEBIOMETRICS_100CS);
#endif
	comboBoxMode->AddItem("STMicroelectronics TouchChip", (void *)VF_MODE_STMICROELECTRONICS_TOUCHCHIP);
#ifndef FINGERCELL
	comboBoxMode->AddItem("IdenticatorTechnology DF-90", (void *)VF_MODE_IDENTICATORTECHNOLOGY_DF90);
#endif
	comboBoxMode->AddItem("Authentec AF-S2", (void *)VF_MODE_AUTHENTEC_AFS2);
	comboBoxMode->AddItem("Authentec AES 4000", (void *)VF_MODE_AUTHENTEC_AES4000);
	comboBoxMode->AddItem("Atmel FingerChip", (void *)VF_MODE_ATMEL_FINGERCHIP);
	comboBoxMode->AddItem("BMF BLP-100", (void *)VF_MODE_BMF_BLP100);
	comboBoxMode->AddItem("Secugen Hamster", (void *)VF_MODE_SECUGEN_HAMSTER);
#ifndef FINGERCELL
	comboBoxMode->AddItem("Ethentica", (void *)VF_MODE_ETHENTICA);
#endif
	comboBoxMode->AddItem("CrossMatch Verifier 300", (void *)VF_MODE_CROSSMATCH_VERIFIER300);
	comboBoxMode->SetLeft(labelMode->Right() + 4);
	comboBoxMode->SetTop(y);
	comboBoxMode->SetWidth(200);
	labelMode->SetVCenter(comboBoxMode->VCenter());
	y += comboBoxMode->Height() + 4;

	int xx, yy;

	CGroupBox * groupBoxExtraction = new CGroupBox();
	groupBoxExtraction->SetText(STRING("Features extraction"));
	groupBoxExtraction->SetLeft(x);
	groupBoxExtraction->SetTop(y);
	xx = groupBoxExtraction->Left() + 8;
	yy = groupBoxExtraction->Top() + 16;
	CLabel * labelReturnedImage = new CLabel();
	labelReturnedImage->SetText(STRING("Re&turned image"));
	labelReturnedImage->SetLeft(xx);
	labelReturnedImage->SetWidth(80);
	comboBoxReturnedImage = new CComboBox();
	comboBoxReturnedImage->SetStyle(cbsDropDownList);
	comboBoxReturnedImage->AddItem(STRING("None"), (void *)VF_RETURNED_IMAGE_NONE);
	comboBoxReturnedImage->AddItem(STRING("Binarized"), (void *)VF_RETURNED_IMAGE_BINARIZED);
	comboBoxReturnedImage->AddItem(STRING("Skeletonized"), (void *)VF_RETURNED_IMAGE_SKELETONIZED);
	comboBoxReturnedImage->SetLeft(labelReturnedImage->Right() + 4);
	comboBoxReturnedImage->SetTop(yy);
	comboBoxReturnedImage->SetWidth(90);
	labelReturnedImage->SetVCenter(comboBoxReturnedImage->VCenter());
	yy += comboBoxReturnedImage->Height() + 8;
	groupBoxExtraction->SetWidth(200);
	groupBoxExtraction->SetHeight(yy - y);

	CGroupBox * groupBoxGeneralization = new CGroupBox();
	groupBoxGeneralization->SetText(STRING("Features generalization"));
	groupBoxGeneralization->SetLeft(x);
	groupBoxGeneralization->SetTop(groupBoxExtraction->Bottom() + 4);
	groupBoxGeneralization->SetWidth(groupBoxExtraction->Width());
	xx = groupBoxGeneralization->Left() + 8;
	yy = groupBoxGeneralization->Top() + 16;
	CLabel * labelGeneralizationFar;
	CreateFarControls(xx, yy, 25, TEXT("F&AR"), labelGeneralizationFar, comboBoxGeneralizationFar);
	labelGeneralizationFar->SetGroup(true);
	yy += 4;
	CLabel * labelGenMaximalRotation;
	CreateMaximalRotationControls(xx, yy, 80, TEXT("Maxima&l rotation"), labelGenMaximalRotation, editGenMaximalRotation);
	yy += 8;

	CGroupBox * groupBoxMatching = new CGroupBox();
	groupBoxMatching->SetText(STRING("Features matching"));
	groupBoxMatching->SetLeft(groupBoxExtraction->Right() + 4);
	groupBoxMatching->SetTop(y);
	yy = y + 16;
	xx = groupBoxMatching->Left() + 8;
	CLabel * labelMatchingFar;
	CreateFarControls(xx, yy, 25, TEXT("&FAR"), labelMatchingFar, comboBoxMatchingFar);
	labelMatchingFar->SetGroup(true);
	yy += 4;
	CLabel * labelMatchingSpeed = new CLabel();
	labelMatchingSpeed->SetText(STRING("&Speed:"));
	labelMatchingSpeed->SetLeft(xx);
	labelMatchingSpeed->SetTop(yy);
	labelMatchingSpeed->SetWidth(40);
	yy += labelMatchingSpeed->Height();
	CLabel * labelMatchingSpeedLow = new CLabel();
	labelMatchingSpeedLow->SetText(STRING("Low"));
	labelMatchingSpeedLow->SetWidth(20);
	CLabel * labelMatchingSpeedHigh = new CLabel();
	labelMatchingSpeedHigh->SetText(STRING("High"));
	labelMatchingSpeedHigh->SetWidth(24);
	trackBarMatchingSpeed = new CTrackBar();
	trackBarMatchingSpeed->SetFirstBuddy(labelMatchingSpeedLow);
	trackBarMatchingSpeed->SetLastBuddy(labelMatchingSpeedHigh);
	trackBarMatchingSpeed->SetMin(0);
	trackBarMatchingSpeed->SetMax(1);
	trackBarMatchingSpeed->SetLeft(labelMatchingSpeed->Right() + 4);
	trackBarMatchingSpeed->SetTop(yy);
	yy += trackBarMatchingSpeed->Height() + 8;
	CLabel * labelMaximalRotation;
	CreateMaximalRotationControls(xx, yy, 80, TEXT("Maximal &rotation"), labelMaximalRotation, editMaximalRotation);
	yy += 8;
	groupBoxMatching->SetHeight(yy - y);
	groupBoxMatching->SetWidth(200);
	groupBoxGeneralization->SetHeight(groupBoxMatching->Bottom() - groupBoxGeneralization->Top());

	y += groupBoxMatching->Height() + 12;
	x = groupBoxMatching->Right();

	buttonOK = new CButton();
	buttonOK->SetDefault(true);
	buttonOK->SetModalResult(IDOK);
	buttonOK->SetText(STRING("OK"));
	buttonCancel = new CButton();
	buttonCancel->SetCancel(true);
	buttonCancel->SetModalResult(IDCANCEL);
	buttonCancel->SetText(STRING("Cancel"));
	buttonDefault = new CButton();
	buttonDefault->SetText(STRING("&Default"));
	buttonDefault->SetTop(y);
	buttonDefault->SetRight(x);
	buttonCancel->SetTop(buttonDefault->Top());
	buttonCancel->SetRight(buttonDefault->Left() - 8);
	buttonOK->SetTop(buttonCancel->Top());
	buttonOK->SetRight(buttonCancel->Left() - 8);

	x += 8;
	y += buttonDefault->Height() + 8;
	SetClientSize(x, y);

	AddControl(labelMode);
	AddControl(comboBoxMode);

	AddControl(labelReturnedImage);
	AddControl(comboBoxReturnedImage);
	AddControl(groupBoxExtraction);

	AddControl(labelGeneralizationFar);
	AddControl(comboBoxGeneralizationFar);
	AddControl(labelGenMaximalRotation);
	AddControl(editGenMaximalRotation);
	AddControl(groupBoxGeneralization);

	AddControl(labelMatchingFar);
	AddControl(comboBoxMatchingFar);
	AddControl(labelMatchingSpeed);
	AddControl(labelMatchingSpeedLow);
	AddControl(labelMatchingSpeedHigh);
	AddControl(trackBarMatchingSpeed);
	AddControl(labelMaximalRotation);
	AddControl(editMaximalRotation);
	AddControl(groupBoxMatching);

	AddControl(buttonOK);
	AddControl(buttonCancel);
	AddControl(buttonDefault);

	SetActiveControl(comboBoxMode);
}

void CVFOptionsForm::CreateFarControls(int x, int &y, int w, const string &name, CLabel * &label, CComboBox * &comboBox)
{
	label = new CLabel();
	label->SetText(name);
	label->SetLeft(x);
	label->SetWidth(w);
	comboBox = new CComboBox();
	comboBox->SetStyle(cbsDropDown);
	comboBox->AddItem(STRING("0.1%"));
	comboBox->AddItem(STRING("0.01%"));
	comboBox->AddItem(STRING("0.001%"));
	comboBox->SetLeft(label->Right() + 4);
	comboBox->SetTop(y);
	comboBox->SetWidth(70);
	label->SetVCenter(comboBox->VCenter());
	y += comboBox->Height();
}

void CVFOptionsForm::CreateMaximalRotationControls(int x, int &y, int w, const string &name, CLabel * &label, CEdit * &edit)
{
	label = new CLabel();
	label->SetText(name);
	label->SetLeft(x);
	label->SetWidth(w);
	edit = new CEdit();
	edit->SetLeft(label->Right() + 4);
	edit->SetTop(y);
	edit->SetWidth(40);
	label->SetVCenter(edit->VCenter());
	y += edit->Height();
}

void CVFOptionsForm::SetDefaultOptions()
{
	SetOptions(vfDefaultOptions);
}

void CVFOptionsForm::OnCommand(WORD /*id*/, WORD event, CControl * control)
{
	if(control)
	{
		if(event == BN_CLICKED)
		{
			if(control == buttonDefault)
				SetDefaultOptions();
		}
	}
}

void CVFOptionsForm::CheckFar(CComboBox * comboBox, const string &/*name*/)
{
	try
	{
		GetMatchingThreshold(comboBox);
	}
	catch(exception &)
	{
		comboBox->SetFocus();
		throw;
	}
}

void CVFOptionsForm::CheckMaximalRotation(CEdit * edit)
{
	try
	{
		int value = GetMaximalRotation(edit);
		if(value < VFDIR_0 || value > VFDIR_180)
			throw exception("Maximal rotation have to be in range from 0 to 180");
	}
	catch(exception &)
	{
		edit->SetFocus();
		throw;
	}
}

bool CVFOptionsForm::OnCloseQuery()
{
	if(ModalResult() == IDOK)
	{
		try
		{
			CheckFar(comboBoxGeneralizationFar, TEXT("Generalization"));
			CheckMaximalRotation(editGenMaximalRotation);
			CheckFar(comboBoxMatchingFar, TEXT("Matching"));
			CheckMaximalRotation(editMaximalRotation);
			return true;
		}
		catch(exception &e)
		{
			ErrorBox(this, e);
		}
		return false;
	}
	else return true;
}

void CVFOptionsForm::GetOptions(VFOptions &value)
{
	value.mode = (int)comboBoxMode->Value(comboBoxMode->ItemIndex());

	value.returnedImage = (int)comboBoxReturnedImage->Value(comboBoxReturnedImage->ItemIndex());

	value.generalizationThreshold = GetMatchingThreshold(comboBoxGeneralizationFar);
	value.genMaximalRotation = GetMaximalRotation(editGenMaximalRotation);

	value.matchingThreshold = GetMatchingThreshold(comboBoxMatchingFar);
	value.matchingSpeed = trackBarMatchingSpeed->Position() == 1 ? VF_MATCHING_SPEED_HIGH : VF_MATCHING_SPEED_LOW;
	value.maximalRotation = GetMaximalRotation(editMaximalRotation);
}

void CVFOptionsForm::SetOptions(const VFOptions &value)
{
	comboBoxMode->SetItemIndex(comboBoxMode->IndexOfValue((void *)value.mode));

	comboBoxReturnedImage->SetItemIndex(comboBoxReturnedImage->IndexOfValue((void *)value.returnedImage));

	SetMatchingThreshold(comboBoxGeneralizationFar, value.generalizationThreshold);
	SetMaximalRotation(editGenMaximalRotation, value.genMaximalRotation);

	SetMatchingThreshold(comboBoxMatchingFar, value.matchingThreshold);
	trackBarMatchingSpeed->SetPosition(value.matchingSpeed == VF_MATCHING_SPEED_HIGH ? 1 : 0);
	SetMaximalRotation(editMaximalRotation, value.maximalRotation);
}

//////////////////
//              //
// VFOptionsBox //
//              //
//////////////////

bool VFOptionsBox(CForm * owner, VFOptions &options, const string &caption)
{
	CVFOptionsForm * form = new CVFOptionsForm();
	form->SetOwner(owner);
	form->SetOptions(options);
	form->SetText(caption);
	bool ok = form->ShowModal() == IDOK;
	if(ok)
	{
		form->GetOptions(options);
	}
	delete form;
	return ok;
}
