import java.awt.Dimension;
import java.awt.Frame;
import java.awt.HeadlessException;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.SwingConstants;

import VeriFinger.VeriFingerException;
import VeriFinger.VeriFingerWrapper;

/**
 * VeriFinger software protection dialog.
 * It will be displayed if you use demo application
 * with software-protected VeriFinger DLL
 *
 * @version 1.0 04/07/2002
 */
public class RegistrationDlg extends JDialog implements ActionListener {

        /**
         * Constructor for RegistrationDlg.
         * @param owning frame
         * @throws HeadlessException
         */
        public RegistrationDlg(Frame owner) throws HeadlessException {
                super(owner, true);
                // dispose on exit
                addWindowListener(new WindowAdapter() {
                        public void windowClosing(WindowEvent e) {
                                dispose();
                        }
                });

                try {
                        initGui();
                }
                catch (Exception e) {
                        e.printStackTrace();
                }
                this.setResizable(false);
                this.setTitle("Registration");
                this.setSize(510, 210);
                this.centerOnScreen();
        }

        public void centerOnScreen() {
                Dimension dim = getToolkit().getScreenSize();
                Rectangle bounds = getBounds();
                setLocation(
                        (dim.width - bounds.width) / 2,
                        (dim.height - bounds.height) / 2);
                super.setVisible(true);
                requestFocus();
        }

        public void actionPerformed(ActionEvent e) {
                Object source = e.getSource();
                if (source == cancelBtn) {
                        dispose();
                }
                else if (source == okBtn) {
                        Settings.regParam = customerIdFld.getText();
                        Settings.registrationKey = registrationFld.getText();
                        dispose();
                }
                else if (source == generateBtn) {
                        String id = customerIdFld.getText();

                        String cid = "";
                        try {
                                cid = VeriFingerWrapper.VFGenerateId(id);
                        } catch (VeriFingerException vfe) {
                        } catch (Exception ex) {
                        }
                        if (cid.equals("")) {
                                JOptionPane.showMessageDialog(this, "Errror generating id!");
                        }
                        else computerIdFld.setText(cid);
                }
        }
        /**
         * Initialize dialog
         * */
        private void initGui() throws Exception {
                this.getContentPane().setLayout(null);

                generateBtn.setBounds(new Rectangle(405, 53, 90, 22));
                generateBtn.setText("Generate");
                generateBtn.addActionListener(this);
                customerIdLbl.setText("Serial number:");
                computerIdLbl.setText("Registration id:");
                customerIdLbl.setHorizontalAlignment(SwingConstants.RIGHT);
                customerIdLbl.setBounds(new Rectangle(15, 16, 104, 17));


                computerIdLbl.setHorizontalAlignment(SwingConstants.RIGHT);
                computerIdLbl.setBounds(new Rectangle(15, 54, 104, 17));

                registrationLbl.setText("Registration key:");
                registrationLbl.setHorizontalAlignment(SwingConstants.RIGHT);
                registrationLbl.setBounds(new Rectangle(15, 95, 104, 17));

                customerIdFld.setBounds(new Rectangle(129, 16, 270, 21));
                customerIdFld.setText(Settings.regParam);

                computerIdFld.setBounds(new Rectangle(129, 54, 270, 21));
                computerIdFld.setEditable(false);

                registrationFld.setBounds(new Rectangle(129, 93, 270, 21));
                registrationFld.setText(Settings.registrationKey);

                okBtn.setBounds(new Rectangle(320, 151, 79, 27));
                okBtn.setText("OK");
                okBtn.addActionListener(this);
                cancelBtn.setBounds(new Rectangle(410, 151, 79, 27));
                cancelBtn.setText("Cancel");
                cancelBtn.addActionListener(this);
                this.getContentPane().add(customerIdFld, null);
                this.getContentPane().add(computerIdFld, null);
                this.getContentPane().add(registrationLbl, null);
                this.getContentPane().add(registrationFld, null);
                this.getContentPane().add(customerIdLbl, null);
                this.getContentPane().add(computerIdLbl, null);
                this.getContentPane().add(generateBtn, null);
                this.getContentPane().add(cancelBtn, null);
                this.getContentPane().add(okBtn, null);
        }

        // components
        JButton generateBtn = new JButton();
        JLabel customerIdLbl = new JLabel();
        JTextField customerIdFld = new JTextField();
        JLabel computerIdLbl = new JLabel();
        JTextField computerIdFld = new JTextField();
        JLabel registrationLbl = new JLabel();
        JTextField registrationFld = new JTextField();
        JButton okBtn = new JButton();
        JButton cancelBtn = new JButton();
}
