/********************************************************\
|*                                                      *|
|*                  VeriFinger 5.0 SDK                  *|
|*                                                      *|
|*  VFingerX.cpp                                        *|
|*    Source file for extended VeriFinger features      *|
|*                                                      *|
|*  Copyright (C) 1998-2006 Neurotechnologija           *|
|*                                                      *|
\********************************************************/

//#if defined(linux) || defined (__LINUX__)
//	#include "linux_include.h"
//#else
	#include "stdafx.h"
//#endif

#include "VFingerX.h"
#include <math.h>


DWORD VFDecompressFeatures(const BYTE * features, VFFEATURES * f)
{
	f->g = VFFeatGetG(features);

	VFFeatGetBOSize(features, &f->bo.width, &f->bo.height);
	VFFeatGetBO(features, (BYTE*) f->bo.bits);

	f->m.count = VFFeatGetMinutiaCount(features);
	if (f->m.count > 0)
	{
		VFMinutia* m = new VFMinutia[f->m.count];
		VFFeatGetMinutiae(features, m);

		for (int i = 0; i < f->m.count; i++)
		{
			f->m.x[i] = m[i].X;
			f->m.y[i] = m[i].Y;
			f->m.c[i] = m[i].C;
			f->m.d[i] = m[i].D;
		}
		delete[] m;
	}

	f->sp.count = VFFeatGetSPCount(features);
	if (f->sp.count > 0)
	{
		VFSingularPoint* sp = new VFSingularPoint[f->sp.count];
		VFFeatGetSP(features, sp);

		for (int i = 0; i < f->sp.count; i++)
		{
			f->sp.x[i] = sp[i].X;
			f->sp.y[i] = sp[i].Y;
			f->sp.t[i] = sp[i].T;
			f->sp.d[i] = sp[i].D;
		}
		delete[] sp;
	}
	return 0;
}


DWORD VFCompressFeatures(const VFFEATURES * f, BYTE * features)
{
	int ret = 0;

	VFMinutia* m = NULL;
	VFSingularPoint* sp = NULL;

	if (f->m.count > 0)
	{
		m = new VFMinutia[f->m.count];
		for (int i = 0; i < f->m.count; i++)
		{
			m[i].X = f->m.x[i];
			m[i].Y = f->m.y[i];
			m[i].C = f->m.c[i];
			m[i].D = f->m.d[i];
		}
	}

	if (f->sp.count > 0)
	{
		sp = new VFSingularPoint[f->sp.count];
		for (int i = 0; i < f->sp.count; i++)
		{
			sp[i].X = f->sp.x[i];
			sp[i].Y = f->sp.y[i];
			sp[i].T = (VFSingularPointType) f->sp.t[i];
			sp[i].D = f->sp.d[i];
		}
	}

	ret = VFFeatSet(f->g, f->m.count, m, f->sp.count, sp, f->bo.width, f->bo.height, (BYTE*) f->bo.bits, features);

	if (m != NULL)
		delete[] m;
	
	if (sp != NULL)
		delete[] sp;

	return ret;
}
