/********************************************************\
|*                                                      *|
|*                  VeriFinger 5.0 SDK                  *|
|*                                                      *|
|*  2DByteArray.cpp                                     *|
|*    C2DByteArray class implementation                 *|
|*                                                      *|
|*  Copyright (C) 1998-2006 Neurotechnologija           *|
|*                                                      *|
\********************************************************/

#include <windows.h>
#include "2DByteArray.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

C2DByteArray::C2DByteArray()
{
        m_Buffer = NULL;
        m_row = NULL;
        m_sx =0;
        m_sy =0;
}

C2DByteArray::~C2DByteArray()
{
        Reset();
}

bool C2DByteArray::Set(DWORD y, DWORD x)
{
        if(m_sx == x && m_sy == y)
                return true;
        Reset();
        m_Buffer = (BYTE **)calloc(y,sizeof(BYTE*));
        if(!m_Buffer)
                return false;
        BYTE * mass = (BYTE*)calloc(x*y,sizeof(BYTE));
        if(!mass){
                free(m_Buffer);
                m_Buffer = NULL;
                return false;
        }
        m_row = mass;
        for(DWORD yy = 0; yy<y; yy++){
                m_Buffer[y-yy-1] = mass;
                mass+=x;
        }
        m_sx = x;
        m_sy = y;
        return true;
}

bool C2DByteArray::Reset()
{
        if(!m_Buffer)
                return false;
        free(m_row);
        free(m_Buffer);
        m_Buffer = NULL;
        m_row = NULL;
        m_sx =0;
        m_sy =0;
        return true;
}

BYTE ** C2DByteArray::GetBuffer()
{
        return m_Buffer;
}

bool C2DByteArray::Clone(C2DByteArray * target)
{
        if(!m_Buffer)
                return false;
        if(m_sy!=target->m_sy || m_sx!=target->m_sx){
                if(!target->Set(m_sy,m_sx))
                        return false;
        }
        CopyMemory(target->m_row,m_row,m_sx*m_sy);
        return true;
}


bool C2DByteArray::Zerro()
{
        if(!m_Buffer)
                return false;
        memset(m_row,0,m_sx*m_sy);
        return true;
}
