using System;
using System.Collections.Generic;
using System.Text;
using Neurotec.Biometrics.VeriFingerDemo.Properties;
using System.Reflection;
using System.Configuration;
using System.ComponentModel;

namespace Neurotec.Biometrics.VeriFingerDemo
{
	static class SettingsUtils
	{
		public static void ResetSetting(string name)
		{
			Settings settings = Settings.Default;
			PropertyInfo pi = typeof(Settings).GetProperty(name);
			DefaultSettingValueAttribute dsva = (DefaultSettingValueAttribute)pi.GetCustomAttributes(typeof(DefaultSettingValueAttribute), false)[0];
			pi.SetValue(settings, TypeDescriptor.GetConverter(pi.PropertyType).ConvertFromInvariantString(dsva.Value), null);
		}

		public static void UpdateVfe(VFExtractor vfExtractor)
		{
			Settings settings = Settings.Default;
			try { vfExtractor.Mode = settings.VfeMode; }
			catch { }
			try { vfExtractor.TemplateSize = settings.VfeTemplateSize; }
			catch { }
			try { vfExtractor.ReturnedImage = settings.VfeReturnedImage; }
			catch { }
			try { vfExtractor.GeneralizationThreshold = settings.VfeGeneralizationThreshold; }
			catch { }
			try { vfExtractor.GeneralizationMaximalRotation = settings.VfeGeneralizationMaximalRotation; }
			catch { }
		}

		public static void UpdateVfeSettings(VFExtractor vfExtractor)
		{
			Settings settings = Settings.Default;
			settings.VfeMode = vfExtractor.Mode;
			settings.VfeTemplateSize = vfExtractor.TemplateSize;
			settings.VfeReturnedImage = vfExtractor.ReturnedImage;
			settings.VfeGeneralizationThreshold = vfExtractor.GeneralizationThreshold;
			settings.VfeGeneralizationMaximalRotation = vfExtractor.GeneralizationMaximalRotation;
		}

		public static void UpdateVfm(VFMatcher vfMatcher)
		{
			Settings settings = Settings.Default;
			try { vfMatcher.Mode = settings.VfmMode; }
			catch { }
			try { vfMatcher.MatchingThreshold = settings.VfmMatchingThreshold; }
			catch { }
			try { vfMatcher.MaximalRotation = settings.VfmMaximalRotation; }
			catch { }
		}

		public static void UpdateVfmSettings(VFMatcher vfMatcher)
		{
			Settings settings = Settings.Default;
			settings.VfmMode = vfMatcher.Mode;
			settings.VfmMatchingThreshold = vfMatcher.MatchingThreshold;
			settings.VfmMaximalRotation = vfMatcher.MaximalRotation;
		}
	}
}
