/* $Id: register_window.c 9210 2006-09-19 07:43:25Z grazvydas $ */
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>

#include "fp_engine.h"

struct param {
	GtkWidget *entry1;
	GtkWidget *entry2;
};

static void
generate_id(GtkWidget *widget, gpointer user_data)
{
	/* FIXME: protection */
/*
	char id[100];
	char *sn;
	int ret;
	struct param *p = (struct param *)user_data;
	sn = (char *)gtk_entry_get_text(GTK_ENTRY(p->entry1));

	ret = VFGenerateId(sn, id);
	if (ret == 0)
	{
		gtk_entry_set_text(GTK_ENTRY(p->entry2), id);
	}
	else
	{
		GtkWidget *w;
		char temp[100];

		snprintf(temp, sizeof(temp), "Id generation failed: %i", ret);
		w = gtk_message_dialog_new(NULL, GTK_DIALOG_MODAL,
			GTK_MESSAGE_INFO, GTK_BUTTONS_CLOSE,
			temp);
		gtk_dialog_run(GTK_DIALOG(w));
		gtk_widget_destroy(w);
	}
*/
}

void
register_window(void)
{
	GtkWidget *window;
	GtkWidget *table;
	GtkWidget *vbox;
	GtkWidget *hbox;

	GtkWidget *button_generate;
	GtkWidget *button;
	GtkWidget *entry1;
	GtkWidget *entry2;
	GtkWidget *entry3;
	GtkWidget *label;
	GtkWidget *dialog_action_area1;
	struct param p;
	int ret;

	window = gtk_dialog_new();
	gtk_window_set_title(GTK_WINDOW(window), "Register");
	gtk_window_set_resizable(GTK_WINDOW(window), FALSE);
	gtk_dialog_set_has_separator(GTK_DIALOG(window), FALSE);

	vbox = GTK_DIALOG(window)->vbox;
	gtk_widget_show(vbox);

	table = gtk_table_new(3, 2, FALSE);
	gtk_widget_show(table);
	gtk_box_pack_start(GTK_BOX(vbox), table, TRUE, TRUE, 0);
	gtk_table_set_row_spacings(GTK_TABLE(table), 2);
	gtk_table_set_col_spacings(GTK_TABLE(table), 2);

	hbox = gtk_hbox_new(FALSE, 3);
	gtk_widget_show(hbox);
	gtk_table_attach(GTK_TABLE(table), hbox, 1, 2, 0, 1,
		   (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
		   (GtkAttachOptions)(GTK_EXPAND | GTK_FILL), 0, 0);

	entry1 = gtk_entry_new();
	gtk_widget_show(entry1);
	gtk_box_pack_start(GTK_BOX(hbox), entry1, TRUE, TRUE, 0);

	button_generate = gtk_button_new_with_mnemonic("Generate Id");
	gtk_widget_show(button_generate);
	gtk_box_pack_start(GTK_BOX(hbox), button_generate, FALSE, FALSE, 0);

	label = gtk_label_new("Serial number");
	gtk_widget_show(label);
	gtk_table_attach(GTK_TABLE(table), label, 0, 1, 0, 1,
		   (GtkAttachOptions)(GTK_FILL),
		   (GtkAttachOptions)(0), 0, 0);
	gtk_misc_set_alignment(GTK_MISC(label), 0, 0.5);

	label = gtk_label_new("Registration id");
	gtk_widget_show(label);
	gtk_table_attach(GTK_TABLE(table), label, 0, 1, 1, 2,
		   (GtkAttachOptions)(GTK_FILL),
		   (GtkAttachOptions)(0), 0, 0);
	gtk_misc_set_alignment(GTK_MISC(label), 0, 0.5);

	entry2 = gtk_entry_new();
	gtk_widget_show(entry2);
	gtk_table_attach(GTK_TABLE(table), entry2, 1, 2, 1, 2,
		   (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
		   (GtkAttachOptions)(0), 0, 0);

	entry3 = gtk_entry_new();
	gtk_widget_show(entry3);
	gtk_table_attach(GTK_TABLE(table), entry3, 1, 2, 2, 3,
		   (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
		   (GtkAttachOptions)(0), 0, 0);

	label = gtk_label_new("Registration key");
	gtk_widget_show(label);
	gtk_table_attach(GTK_TABLE(table), label, 0, 1, 2, 3,
		   (GtkAttachOptions)(GTK_FILL),
		   (GtkAttachOptions)(0), 0, 0);
	gtk_misc_set_alignment(GTK_MISC(label), 0, 0.5);

	dialog_action_area1 = GTK_DIALOG(window)->action_area;
	gtk_widget_show(dialog_action_area1);
	gtk_button_box_set_layout(GTK_BUTTON_BOX(dialog_action_area1), GTK_BUTTONBOX_END);

	button = gtk_button_new_from_stock("gtk-cancel");
	gtk_widget_show(button);
	gtk_dialog_add_action_widget(GTK_DIALOG(window), button, GTK_RESPONSE_CANCEL);
	GTK_WIDGET_SET_FLAGS(button, GTK_CAN_DEFAULT);

	button = gtk_button_new_from_stock("gtk-ok");
	gtk_widget_show(button);
	gtk_dialog_add_action_widget(GTK_DIALOG(window), button, GTK_RESPONSE_OK);
	GTK_WIDGET_SET_FLAGS(button, GTK_CAN_DEFAULT);

	p.entry1 = entry1;
	p.entry2 = entry2;

	g_signal_connect (G_OBJECT(button_generate), "clicked",
		G_CALLBACK(generate_id), &p);

	ret = gtk_dialog_run(GTK_DIALOG(window));
	if (GTK_RESPONSE_OK == ret)
	{
		char *p, *sn, *key;
		GtkWidget *w;


		p = (char *)gtk_entry_get_text(GTK_ENTRY(entry1));
		if (!p) goto fail;
		sn = strdup(p);
		p = (char *)gtk_entry_get_text(GTK_ENTRY(entry3));
		if (!p) goto fail;
		key = strdup(p);

		// FIXME
//		ret = VFRegister(sn, key);
		ret = 1;

		free(sn);
		free(key);
		if (ret == 0)
		{
			w = gtk_message_dialog_new(NULL, GTK_DIALOG_MODAL,
				GTK_MESSAGE_INFO, GTK_BUTTONS_CLOSE,
				"Library registered!");
		}
		else
		{
			w = gtk_message_dialog_new(NULL, GTK_DIALOG_MODAL,
				GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
				"Registration failed! Check registration key "
				"or serial number.");
		}
		gtk_dialog_run(GTK_DIALOG(w));
		gtk_widget_destroy(w);
	}
fail:
	gtk_widget_destroy(window);
}
