#ifndef _FXDRIVER_H_
#define _FXDRIVER_H_

#include <linux/ioctl.h> /* needed for the _IOW etc stuff used later */
#include <linux/devfs_fs_kernel.h>

/*
 * Macros to help debugging
 */

#ifdef FXDRIVER_DEBUG
#  ifdef __KERNEL__
     /* This one if debugging is on, and kernel space */
#    define FXDRIVER_DEBUG(fmt, args...) printk("<1>FxDriver: " fmt, ## args)
#    define FXDRIVER_DEBUGnoC(fmt, args...) printk(fmt, ## args)
#  else
     /* This one for user space */
#    define FXDRIVER_DEBUG(fmt, args...) fprintf(stderr, fmt, ## args)
#  endif
#else
#  define FXDRIVER_DEBUG(fmt, args...) /* not debugging: nothing */
#endif

#ifndef FXDRIVER_MAJOR
#define FXDRIVER_MAJOR 0   /* dynamic major by default */
#endif

#ifndef FXDRIVER_NR_DEVS
#define FXDRIVER_NR_DEVS 10    /* fx2000_0 through fx2000_9 or fx3000_0 through fx3000_9 */
#endif

#endif /* _FXDRIVER_H_ */
